<?php
/*
Plesk Greylisting Control Panel (Version see version.php) - GUI for Plesk greylisting implementation

Copyright (C) [2008] [Matthias Hackbarth / www.haggybear.de]

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty 
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, see <http://www.gnu.org/licenses/>.
*/

DEFINE("GLM_ADMIN","Greylisting Control Panel");
DEFINE("GLM_VERSION_OK","Your version is up to date");
DEFINE("GLM_VERSION_NOK","Version {VER} available - download now?");
DEFINE("GLM_VERSION_UPD","Version {VER} available - update now?");
DEFINE("GLM_GREYLISTING_NO_ACTIVE","The greylisting is not active, please activate at first:<br><br>Settings->Spam Filter Settings->Switch on server-wide greylisting spam protection");
DEFINE("GLM_RIGHT_LISTS","You have no permissions to edit the white/blacklists, please contact your administrator");
DEFINE("GLM_NO_GREYLISTING_SUPPORT","Greylisting is not installed or not supported by the Plesk Version");
DEFINE("GLM_LEVEL_UP","Level up");
DEFINE("GLM_DAYS","days");
DEFINE("GLM_MINUTES","minutes");
DEFINE("GLM_SECONDS","seconds");
DEFINE("GLM_TRIES","tries");
DEFINE("GLM_ADMIN_JS_ONLY_NUM","Only numbers are allowed");
DEFINE("GLM_ADMIN_JS_NOT_EMPTY","No empty input allowed");
DEFINE("TOTAL_SUMMARY","Total summary");
DEFINE("GLM_ADMIN_PAGE","Administration");
DEFINE("GLM_ADMIN_SAVE","save");
DEFINE("GREYINTERVAL","Delay between two deliveries");
DEFINE("EXPIREINTERVAL","Time until entry expires");
DEFINE("PENALTYENABLED","Enable penaltyfunction of greylisting");
DEFINE("PENALTYENABLED_YES","yes");
DEFINE("PENALTYENABLED_NO","no");
DEFINE("PENALTYINTERVAL","Penaltytime");
DEFINE("DOMAIN_SUMMARY","Domain summery");
DEFINE("WHITELIST","White/Blacklist");
DEFINE("P_WHITELIST","Pers.White/Blacklist");
DEFINE("WHITELISTS_NOTICE","Warning! All listentries depending to the the reverse DNS name. E-Mail addresses and part of it <u>can't</u> be add to the list.<br><br><b>E-Mails which are automaticaly accepted from the whitelist or blocked from the blacklist, are <u>not</u> shown in the overview!</b>");
DEFINE("WHITELISTS_NOTICE_ENTRY","The received IP(%s) for the whitelist has been resolved into the RDNS-name(%s)");                                           
DEFINE("BLACKLISTS_NOTICE_ENTRY","The received IP(%s) for the blacklist has been resolved into the RDNS-name(%s)");  
DEFINE("P_WHITELISTS_NOTICE_ENTRY","The E-Mail (%s) was set onto the whitelist of E-Mail (%s)");
DEFINE("P_BLACKLISTS_NOTICE_ENTRY","The E-Mail (%s) was set onto the blacklist of E-Mail (%s)");
DEFINE("MAILS_TOTAL","Mails total");
DEFINE("MAILS_ALL","complete");
DEFINE("ALL_REQUESTS","All requests");
DEFINE("NOK_REQUESTS","Unconfirmed requests");
DEFINE("OK_REQUESTS","Confirmed requests");
DEFINE("WHITELISTS","Server White/Blacklists");
DEFINE("WHITELIST_DIRECT","Server Whitelist");
DEFINE("BLACKLIST_DIRECT","Server Blacklist");
DEFINE("P_WHITELIST","Personal White/Blacklists");
DEFINE("P_WHITELIST_DIRECT","Personal Whitelists");
DEFINE("P_BLACKLIST_DIRECT","Personal Blacklists");
DEFINE("NOTICE_LISTS_DIRECT","Should the entry be placed quietly onto the %s,\\nor do you prefer to change into %s-settings first?");
DEFINE("SPAM_RATE","Spam rate");
DEFINE("SHOW_ENTRY","Show entries");
DEFINE("SHOW_ALL","all");
DEFINE("SHOW_BLOCK","blocked");
DEFINE("SHOW_PASS","passed");
DEFINE("IPTOWHITE","IP to whitelist");
DEFINE("IPTOBLACK","IP or domain to blacklist");
DEFINE("EMAIL_SENDER","Sender email<br>(Wildcards \"*\" only possible if recipient exists!)");
DEFINE("EMAIL_RECIEP","Recipient email<br>(Wildcards not possible!)");
DEFINE("USED_GL_TEXT","White/Blacklist-Management for Plesk greylisting sourcen version ");
DEFINE("WHITELIST_SENDER","Sender");
DEFINE("WHITELIST_RECIEP","Recipient");
DEFINE("ADDIPTOWHITE","add");
DEFINE("WHOLEDOMAIN","Whole domain to whitelist");
DEFINE("EXIST_WHILTELIST","Existing whitelistes");
DEFINE("EXIST_BLACKLIST","Existing blacklistes");
DEFINE("WHITELIST_IP","IP");
DEFINE("WHITELIST_DOM","Domain");
DEFINE("WHITELIST_ADDED","Added");
DEFINE("WHITELIST_PLS_BOTH","Please enter sender AND recipient");
DEFINE("FROM_IP","from IP");
DEFINE("FROM_MAIL","from mail");
DEFINE("TO_MAIL","to mail");
DEFINE("BLOCKED","blocked");
DEFINE("PASSED","accepted");
DEFINE("EXPIRES","expires at");
DEFINE("AKT_PAGE","Page");
DEFINE("AKT_SUM","of");
DEFINE("PREV_PAGE","previous page");
DEFINE("NEXT_PAGE","next page");
DEFINE("SEARCH_ENTRY","search entries");
DEFINE("SEARCH_IT","search!");

DEFINE("ENTRY_AT","Entry created");
DEFINE("LAST_UPDATE","Last update");
DEFINE("PASS_FROM_NOW","Pass in future");
DEFINE("CHECK_AGAIN","check again");
DEFINE("DELETE","delete");
DEFINE("MARK_KILL","delete selected");
DEFINE("MARK_BLOCK","check again selected");
DEFINE("MARK_PASS","pass selected");
DEFINE("KILL_TABLE","Delete all entries");
DEFINE("CRON_JOB","Cleanup table");
DEFINE("GETTING_IP_INFO","Getting IP information");

DEFINE("UPDATE_GLM","Greylisting Control Panel Updater");
DEFINE("UPDATE_DOWN","Downloading new version"); 	
DEFINE("UPDATE_CONFIG","Use existing config"); 	
DEFINE("UPDATE_INSTALL","Install new Version"); 	
DEFINE("UPDATE_DONE","Finish installation"); 	

DEFINE("UPDATE_GLM_OK","success");
DEFINE("UPDATE_GLM_NOK","failed");

DEFINE("UPDATE_GLM_SUCCESS","Update successfully done. Version {VER} installed");
DEFINE("UPDATE_GLM_FAILED","Update failed, please try again");

DEFINE("CHECKING_EMAIL","Checking email");

DEFINE("CLOSE_WINDOW","close");

DEFINE("EMAILCHECK_HEAD_SYNTAX","Checking syntax & MX records");
DEFINE("EMAILCHECK_SYNTAX","Checking email syntax");
DEFINE("EMAILCHECK_SYNTAX_SUCCESS","<font color=\"#006600\">succesful</font>");
DEFINE("EMAILCHECK_SYNTAX_FAILED","<font color=\"#FF0000\">failed</font>");
DEFINE("EMAILCHECK_MX","Checking MX record");
DEFINE("EMAILCHECK_MX_SUCCESS","<font color=\"#006600\">succesful</font>");
DEFINE("EMAILCHECK_MX_FAILED","<font color=\"#FF0000\">failed</font>");
DEFINE("EMAILCHECK_MXRR","Read MX record");
DEFINE("EMAILCHECK_MXRR_SUCCESS","<font color=\"#006600\">{MX}</font>");
DEFINE("EMAILCHECK_MXRR_FAILED","<font color=\"#FF0000\">failed</font>");

DEFINE("EMAILCHECK_HEAD_SERVER","Checking mailserver & email adress");
DEFINE("EMAILCHECK_CONN","Connecting to mailserver");
DEFINE("EMAILCHECK_CONN_SUCCESS","<font color=\"#006600\">connected to {SERVER}</font>");
DEFINE("EMAILCHECK_CONN_FAILED","<font color=\"#FF0000\">failed</font>");
DEFINE("EMAILCHECK_TEST","Testing Mailserver");
DEFINE("EMAILCHECK_TEST_SUCCESS","<font color=\"#006600\">succesful</font>");
DEFINE("EMAILCHECK_TEST_FAILED","<font color=\"#FF0000\">invalid answer</font>");
DEFINE("EMAILCHECK_ADDY","Testing email adress");
DEFINE("EMAILCHECK_ADDY_SUCCESS","<font color=\"#006600\">adress valid</font>");
DEFINE("EMAILCHECK_ADDY_FAILED","<font color=\"#FF0000\">adress invalid</font>");
DEFINE("SERVER_STAT","Statistics");
DEFINE("CSV_EXPORT","CSV export");
DEFINE("CHECKING_DATA","Collection data");
DEFINE("STAT_DOMAIN","Domain");
DEFINE("STAT_ANTEIL","Spam on domain");

DEFINE("GLM_SPAM_REMOTE_ACCESS","User remote access active");
DEFINE("GLM_SPAM_REMOTE_ACCESS_ADMIN","Admin remote access active");

DEFINE("GLM_REMOTE_ACCESS","Remote access:");
DEFINE("GLM_REMOTE_ACCESS_EXAMPLE","Script example how to make the remote access");

DEFINE("GLM_SPAM_ABUSE_REPORT","Spam abuse report active");
DEFINE("GLM_SPAM_ABUSE_REPORT_SENDER","Sender");
DEFINE("GLM_SPAM_ABUSE_REPORT_TITEL","Subject");
DEFINE("GLM_SPAM_ABUSE_REPORT_TPL","Template");
DEFINE("GLM_SPAM_ABUSE_REPORT_SPAMMAIL","Data of the queried mail");
DEFINE("GLM_SPAM_ABUSE_REPORT_DO","Do you want to send an abuse mail to the receipient with the details");
DEFINE("GLM_SPAM_ABUSE_REPORT_DO_OK","The mail was sent, do you want to close the window now?");
DEFINE("GLM_SPAM_ABUSE_REPORT_DO_NOK","The mail was not sent\\n=================================\\n");

DEFINE("VALUE_DEACT","deactived");
DEFINE("VALUE_ACT","active");
DEFINE("ERR_PLISTS","Only complete E-mail addresses (name@domain.com) or wildcards (*@domain.com) are allowed");
DEFINE("NO_FULLSCREEN","Disable fullscreen notice until end of the session");
DEFINE("TOGGLE_FULLSCREEN","You are using Plesk 10, do you want to switch to the fullscreen mode?");

?>